"""Adding constraints user_roles, action_roles, user_groups

Revision ID: 74dd111159d7
Revises: ce0e2afc4743
Create Date: 2017-07-07 16:23:53.794630

"""

# revision identifiers, used by Alembic.
revision = '74dd111159d7'
down_revision = 'ce0e2afc4743'

from alembic import op
import sqlalchemy as sa


INSERTS = """DELETE FROM public.nm_action_roles WHERE EXISTS (SELECT 1 FROM public.nm_action_roles t2 WHERE t2.aid = nm_action_roles.aid AND t2.rid = nm_action_roles.rid AND t2.ctid > nm_action_roles.ctid );"""
DELETES = """"""


def iter_statements(stmts):
    for st in [x for x in stmts.split('\n') if x]:
        op.execute(st)


def upgrade():
    ### commands auto generated by Alembic - please adjust! ###
    iter_statements(INSERTS)
    op.add_column('actions', sa.Column('admin', sa.Boolean(), server_default='0', nullable=False))
    op.create_unique_constraint(None, 'nm_action_roles', ['aid', 'rid'])
    op.create_unique_constraint(None, 'nm_user_roles', ['uid', 'rid'])
    op.create_unique_constraint(None, 'nm_user_usergroups', ['uid', 'gid'])
    ### end Alembic commands ###


def downgrade():
    ### commands auto generated by Alembic - please adjust! ###
    op.drop_constraint(None, 'nm_user_usergroups', type_='unique')
    op.drop_constraint(None, 'nm_user_roles', type_='unique')
    op.drop_constraint(None, 'nm_action_roles', type_='unique')
    op.drop_column('actions', 'admin')
    ### end Alembic commands ###
    iter_statements(DELETES)
